﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Web.UI.HtmlControls;
using System.Collections.Generic;

public partial class adm_sc_abuse_Reports : System.Web.UI.Page
{
    //******************************************************
    // Documentation
    //******************************************************
    // This page is used to load abuse reports posted by users on any content.
    // It can be abuse or spam or flag reports.
    // Reports generated on the following types of contents within video kit.
    // ........... 0: Videos.
    // ........... 1: Channel Comments
    // ........... 2: User Messages
    // ........... 3: Group Topics
    // ........... 4: Video Comments
    // ........... 5: Photos
    // ........... 6: Photo Comments
    // ........... 7: Blogs
    // ........... 8: Blog Comments
    //............ 9: Photo Galleries
    // If administrator clicked on disabled button, content will be disabled as well as report will be removed.
    // If administrator clicked on resolve button, all reports on existing content will be removed without taking action on content.
      
    public int PageNumber
    {
        get
        {
            if (ViewState["PageNumber"] != null)
                return (int)ViewState["PageNumber"];
            else
                return 1;
        }
        set
        {
            ViewState["PageNumber"] = value;
        }
    }

    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);
        rptPages.ItemCommand += this.rptPages_ItemCommand;
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
          
            if (Request.Params["t"] != null)
            {
                // set filter record option
                drp_filter.SelectedValue = Request.Params["t"].ToString();
            }
            if (Request.Params["status"] != null)
            {
                //if (Request.Params["status"] == "deleted")
                //{
                //    Config.ShowMessageV2(msg, "Category has been deleted successfully", 1, 2);

                //}
            }
            BindList();
        }
    }

    private void BindList()
    {
        List<Abuse_Struct> _lst = AbuseReport.Load_Reports(drp_filter.SelectedValue);
        if(_lst.Count>0)
        {
            Pagination_Process.Process_Pagination(MyList, rptPages, lnk_Prev, lnk_Next, 40, this.PageNumber, _lst);
            pnl_main.Visible = true;
            pnl_norecord.Visible = false;
        }
        else
        {
            pnl_main.Visible = false;
            pnl_norecord.Visible = true;
        }

    }
      
    protected void drp_filter_SelectedIndexChanged(object sender, System.EventArgs e)
    {       
        // load category detail list
        BindList();
    }
       
    protected void MyList_ItemCommand(object source, DataListCommandEventArgs e)
    {
        string cmd = ((LinkButton)e.CommandSource).CommandName;
        long contentid = Convert.ToInt64(((Label)e.Item.FindControl("lbl_contentid")).Text);
        string _type = ((Label)e.Item.FindControl("lbl_type")).Text;
        int type = Convert.ToInt32(_type);
        string username = "";
        switch(cmd)
        {
            case "resolve_report":
                AbuseReport.Delete(contentid, type);
                Update_Content_Status(contentid, username, type, 1);
                Config.ShowMessageV2(msg, "Abuse report has been resolved, all reports against it has been removed and content has been enabled if already disabled", "Success!", 1);
                break;
            case "delete_report":
                long reportid = Convert.ToInt64(((Label)e.Item.FindControl("lbl_reportid")).Text);
                AbuseReport.Delete(reportid);
                Config.ShowMessageV2(msg, "Selected Report has been removed successfully", "Success!", 1);
                break;
            case "disable_content":
                Update_Content_Status(contentid, username, type,0);
                Config.ShowMessageV2(msg, "Original content has been disabled successfully", "Success!", 1);
                break;
            case "enable_content":
                Update_Content_Status(contentid, username, type,1);
                Config.ShowMessageV2(msg, "Original content has been enabled successfully", "Success!", 1);
                break;
            case "block_reporter":
                // disable abuse reporter account
                username = ((HyperLink)e.Item.FindControl("lnk_username")).Text;
                Response.Redirect(Config.GetUrl("adm/sc/members/memberdetail.aspx?user=" + username + "&status=doblock"), true);
                break;
            case "block_ipaddress":
                string ipaddress = ((Label)e.Item.FindControl("lbl_ipaddress")).Text;
                BlockIPBLL.Add_IP(ipaddress);
                Config.ShowMessageV2(msg, "IP Address: <strong>" + ipaddress + "</strong> has been blocked.", "Success!", 1);
                break;
            case "block_author":
                // disable content author account
                username = ((HyperLink)e.Item.FindControl("lnk_author")).Text;
                Response.Redirect(Config.GetUrl("adm/sc/members/memberdetail.aspx?user=" + username + "&status=doblock"),true);
                break;
        }
        BindList();
    }
    protected void MyList_ItemDataBound(object sender, DataListItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            // content id
            long contentid = Convert.ToInt64(((Label)e.Item.FindControl("lbl_contentid")).Text);
            // author username 
            HyperLink lnk_username = (HyperLink)e.Item.FindControl("lnk_username");
            lnk_username.NavigateUrl = UrlConfig.Prepare_User_Profile_Url(lnk_username.Text, true); 
            lnk_username.Target = "_blank";
            // content type settings
            Label lbl_type = (Label)e.Item.FindControl("lbl_type");
            int type = Convert.ToInt32(lbl_type.Text);
            Label lbl_abusetype = (Label)e.Item.FindControl("lbl_abusetype");

            // Load Content Information
            HyperLink lnk_title = (HyperLink)e.Item.FindControl("lnk_title");
            HyperLink lnk_author = (HyperLink)e.Item.FindControl("lnk_author");
            Label lbl_status = (Label)e.Item.FindControl("lbl_status");

            int isenabled = 0;
            switch (type)
            {
                case 0:
                    // videos
                    lbl_abusetype.Text = "Video";
                    List<Video_Struct> _vd_struct = VideoBLL.Get_SM_Info(contentid);
                    if (_vd_struct.Count > 0)
                    {
                        lnk_title.Text = _vd_struct[0].Title;
                        if (_vd_struct[0].Type == 0)
                            lnk_title.NavigateUrl = UrlConfig.Prepare_Video_Preview_Url(contentid, _vd_struct[0].Title, true);
                        else
                            lnk_title.NavigateUrl = UrlConfig.Prepare_Audio_Preview_Url(contentid, _vd_struct[0].Title, true);

                        lnk_author.Text = _vd_struct[0].UserName;
                        lnk_author.NavigateUrl = UrlConfig.Prepare_User_Profile_Url(_vd_struct[0].UserName, true);
                        isenabled = _vd_struct[0].isEnabled;
                    }
                    break;
              
              
                case 3:
                    //Group Topics
                    //lbl_abusetype.Text = "Group Topic";
                    //List<Group_Topic_Struct> _gt_struct = Group_Topics.Get_SM_Info(contentid);
                    //if (_gt_struct.Count > 0)
                    //{
                    //    lnk_title.Text = _gt_struct[0].Topic;
                    //    lnk_author.Text = _gt_struct[0].UserName;
                    //    lnk_author.NavigateUrl = UrlConfig.Prepare_User_Profile_Url(_gt_struct[0].UserName, true);
                    //    isenabled = _gt_struct[0].isEnabled;
                    //}
                    break;
                case 4:
                    // Video Comments
                    lbl_abusetype.Text = "Video Comment";
                    List<Comment_Struct> _c_struct = CommentsBLL.Get_SM_Info(contentid,0);
                    if (_c_struct.Count > 0)
                    {
                        lnk_title.Text = _c_struct[0].Comment;
                        lnk_author.Text = _c_struct[0].UserName;
                        lnk_author.NavigateUrl = UrlConfig.Prepare_User_Profile_Url(_c_struct[0].UserName, true);
                        isenabled = _c_struct[0].isEnabled;
                    }
                    break;
               
             
                case 10:
                    // Galleries Comments
                    lbl_abusetype.Text = "Photo Gallery Comments";
                    List<Comment_Struct> _pg_struct = CommentsBLL.Get_SM_Info(contentid,3);
                    if (_pg_struct.Count > 0)
                    {
                        lnk_title.Text = _pg_struct[0].Comment;
                        lnk_author.Text = _pg_struct[0].UserName;
                        lnk_author.NavigateUrl = UrlConfig.Prepare_User_Profile_Url(_pg_struct[0].UserName, true);
                        isenabled = _pg_struct[0].isEnabled;
                    }
                    break;
            }
            if (isenabled == 1)
            {
                lbl_status.Text = "Enabled";
                lbl_status.CssClass = "mini-text green bold";
            }
            else
            {
                lbl_status.Text = "Disabled";
                lbl_status.CssClass = "mini-text red bold";
            }
                     

            // total reports posted on this content
            Label lbl_reports = (Label)e.Item.FindControl("lbl_reports");
            lbl_reports.Text = AbuseReport.Count(contentid, type).ToString();
            //HyperLink l_reports = (HyperLink)e.Item.FindControl("lnk_vreports");
            //l_reports.NavigateUrl = Config.GetUrl("adm/sc/abuse/ViewReports.aspx?cid=" + contentid + "");
        }
    }
    
    protected void lnk_Next_Click(object sender, EventArgs e)
    {
        PageNumber = PageNumber + 1;
        BindList();
    }
    protected void lnk_Prev_Click(object sender, EventArgs e)
    {
        PageNumber = PageNumber - 1;
        BindList();
    }

    protected void rptPages_ItemCommand(object source, RepeaterCommandEventArgs e)
    {
        LinkButton btnPage = (LinkButton)e.Item.FindControl("btnPage");
        PageNumber = int.Parse(btnPage.Text);
        BindList();
    }

    protected void rptPages_ItemDataBound(object sender, RepeaterItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            LinkButton btnPage = (LinkButton)e.Item.FindControl("btnPage");
            if (int.Parse(btnPage.Text) == PageNumber)
            {
                HtmlGenericControl li = (HtmlGenericControl)e.Item.FindControl("nav");
                li.Attributes.Add("class", "active");
            }
        }

    }

    private void Update_Content_Status(long id, string username,int type, int value)
    {
        // Value(0): Disable Contents
        // Value(1): Enable Contents
        long comment_content_id = 0;
        int OldValue = 0;
        switch (type)
        {
            case 0:
                // videos
                OldValue = Convert.ToInt32(VideoBLL.Get_Field_Value(id, "isenabled"));
                VideoBLL.Update_IsEnabled(id,OldValue, value, username, 0);         
                break;
          
            case 3:
                //Group Topics
                //long groupid = Group_Topics.Get_GroupID(id);
                //Group_Topics.Update_Status(groupid, id, value);
                break;
            case 4:
                // Video Comments
                comment_content_id = Convert.ToInt64(CommentsBLL.Get_Field_Value(id, "videoid"));
                string profileid = CommentsBLL.Get_Field_Value(id, "profileid");
                OldValue = Convert.ToInt32(CommentsBLL.Get_Field_Value(id, "isenabled"));
                CommentsBLL.Update_Action(id, OldValue, value, comment_content_id, profileid, 0, "isenabled", true);
                break;
           
          
        }
    }
}
