﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;

public partial class adm_sc_categories_Process : System.Web.UI.Page
{
    public int CategoryID
    {
        get
        {
            if (ViewState["CategoryID"] != null)
                return (int)ViewState["CategoryID"];
            else
                return 0;
        }
        set
        {
            ViewState["CategoryID"] = value;
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        CategoriesBLL.BindCategories(drp_parent, 0, Convert.ToInt32(drp_type.SelectedValue), " No Parent ", "0", true);
        if (!Page.IsPostBack)
        {
            // toggle on | off features in dropdownlist
            Toggle_Dropdown_List(drp_type);
            photoview.Visible = false;
            txt_priority.Text = "0";
            if (Request.Params["cid"] != null)
            {
                
                this.CategoryID = Convert.ToInt32(Request.Params["cid"]);
                Load_Information();

                
            }
           
        }
    }

    private void Load_Information()
    {
        List<Category_Struct_V2> _lst = CategoriesBLL.Load_Categories("", this.CategoryID, 0, 0, 0, "");
        if (_lst.Count > 0)
        {
            txt_categoryname.Text = _lst[0].CategoryName;
            txt_term.Text = _lst[0].Term;
            txt_content.Value = _lst[0].Description;
            txt_priority.Text = _lst[0].Priority.ToString();
            drp_type.SelectedValue = _lst[0].Type.ToString();
            drp_mode.SelectedValue = _lst[0].Mode.ToString();
            drp_parent.SelectedValue = _lst[0].ParentID.ToString();
            drp_status.SelectedValue = _lst[0].isPrivate.ToString();
            lbl_filename.Text = _lst[0].PictureName;
            if (_lst[0].PictureName != "none")
            {
                photoview.Visible = true;
                img.ImageUrl = Config.GetUrl("contents/category/" + _lst[0].PictureName);
            }
        }
    }
    protected void btn_add_Click(object sender, EventArgs e)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect(Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }

        int type = Convert.ToInt32(drp_type.SelectedValue);

        // Upload Photo if Exist
        string filename = Upload_Photo(ph, txt_categoryname.Text);
        if (filename == "")
            return;

        // Add category record in database
        Category_Struct_V2 cat = new Category_Struct_V2();
        bool isUpdate = false;
        if (this.CategoryID > 0)
            isUpdate = true;
        cat.CategoryID = this.CategoryID;
        cat.CategoryName = txt_categoryname.Text;
        cat.Term = txt_term.Text;
        cat.PictureName = filename;
        cat.ParentID = Convert.ToInt32(drp_parent.SelectedValue);
        cat.Mode = Convert.ToInt32(drp_mode.SelectedValue);
        cat.isPrivate = Convert.ToInt32(drp_status.SelectedValue);
        cat.Priority = Convert.ToInt32(txt_priority.Text);
        cat.Type = Convert.ToInt32(drp_type.SelectedValue);

        cat.Description = UtilityBLL.FixCode(txt_content.Value);

        CategoriesBLL.Process(cat,isUpdate);
        if(isUpdate)
            Response.Redirect(Config.GetUrl("adm/sc/categories/Default.aspx?status=updated"));
        else
            Response.Redirect(Config.GetUrl("adm/sc/categories/Default.aspx?status=added"));
    }

    private string Upload_Photo(FileUpload ph, string title)
    {
        // upload photo
        string strPath = Server.MapPath(Request.ApplicationPath) + "/contents/category";

        // validate photo
        if (ph.PostedFile.ContentLength == 0)
        {
            return "none";
        }

        string filename = "";
        filename = FileDownload.Generate_Label(ph.PostedFile.FileName, title, strPath);
        // delete existing image if exist
        if (lbl_filename.Text != "none")
        {
            if (File.Exists(strPath + "/" + lbl_filename.Text))
               File.Delete(strPath + "/" + lbl_filename.Text);
        }
        // validate photo format
        if (!UtilityBLL.isImage(ph.PostedFile.ContentType))
        {
            Config.ShowMessageV2(msg, "Invalid image format, please upload proper photo.", "Error!", 0);
            return "";
        }

        // save photos
        ph.PostedFile.SaveAs(strPath + "/temp/" + filename);
        ph.PostedFile.SaveAs(strPath + "/" + filename); // prepare thumb compatible photo size

        string orignalfilename = strPath + "/temp/" + filename;
        string thumbfilename = strPath + "/" + filename;

        // create small size thumb
        Bitmap mp = Image_Process.CreateThumbnail(orignalfilename, 140);
        if (mp == null)
        {
            Config.ShowMessageV2(msg, Resources.vsk.message_photos_05, "Error!", 0); // Error occured while uploading photo.
            return "";
        }
        mp.Save(thumbfilename);

        //***********************
        // Compress Thumb Photo
        //***********************
        // Thumbs
        Image_Process.SaveJpeg(thumbfilename, mp, 90);

        return filename;
    }

    protected void drp_type_SelectedIndexChanged(object sender, System.EventArgs e)
    {
        // load categories based on selected type
        CategoriesBLL.BindCategories(drp_parent, 0, Convert.ToInt32(drp_type.SelectedValue), " No Parent ", "0",true);
    }

    // Toggle on | off features
    private void Toggle_Dropdown_List(DropDownList drp)
    {
    }

}