﻿using System;
using System.Collections.Generic;

using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class myaccount_UpdateVideoInfo : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        string username = "";
        if (!Page.User.Identity.IsAuthenticated)
        {
            string redirect_url = Config.GetUrl() + "myaccount/UploadVideoInfo.aspx";
            Response.Redirect(Config.GetUrl() + "Login.aspx?ReturnUrl=" + redirect_url);
            return;
        }

        if (Request.Params["vid"] != null)
        {
            long videoid = Convert.ToInt64(Request.Params["vid"]);
            username = Page.User.Identity.Name;

            LoadInfo(videoid, username);
        }

    }

    private void LoadInfo(long videoid,string username)
    {
        List<Video_Struct> _lst = VideoBLL.Load_Video_Basic_Information(videoid);
        if (_lst.Count > 0)
        {
            if (username != _lst[0].UserName)
            {
                // user have no ownership for this video.
                Config.ShowMessageV2(msg, Resources.vsk.update_videoinfo_authorization, "Error!", 0); // "You are not authorized to edit information of selected video"
                main.Visible = false;
                return;
            }
            edit_video_info1.VideoID = videoid;
            edit_video_info1.Categories = _lst[0].Categories;
            edit_video_info1.UserName = _lst[0].UserName;
            edit_video_info1.Title = _lst[0].Title;
            edit_video_info1.Description = _lst[0].Description;
            edit_video_info1.Tags = _lst[0].Tags;
            edit_video_info1.CategoryID = _lst[0].CategoryID;
            edit_video_info1.isPrivate = _lst[0].isPrivate;
            edit_video_info1.isResponse = _lst[0].isResponse;
            edit_video_info1.isRatings = _lst[0].isRatings;
            edit_video_info1.isComments = _lst[0].isComments;

            // load breadcrumb links
            Generate_Breadcrumb("Edit: " + _lst[0].Title);
            // if video is in embed mode
            if (_lst[0].isExternal == 1)
            {
                // embed video
                thumb_lst1.Visible = false;
            }
            else if (_lst[0].isExternal == 1)
            {
                if (_lst[0].Embed_Script != "")
                {
                    // again video is in embed mod
                    thumb_lst1.Visible = false;
                }
            }
            // lst thumbs
            if (_lst[0].isPublished == 1)
            {
                if (_lst[0].ThumbFileName != "" || _lst[0].ThumbFileName==" " || _lst[0].ThumbFileName == "none")
                {
                    thumb_lst1.VideoID = videoid;
                    thumb_lst1.UserName = username;
                    thumb_lst1.selected_thumb = _lst[0].ThumbFileName;
                    thumb_lst1.Thumb_Url = _lst[0].Thumb_Url;
                    string thumb_start_index = "";
                    if (_lst[0].ThumbFileName.Contains("_"))
                    {
                        thumb_start_index = _lst[0].ThumbFileName.Remove(_lst[0].ThumbFileName.LastIndexOf("_"));
                    }
                    thumb_lst1.thumb_start_sequence = thumb_start_index + "_";
                }
                else
                {
                    // error in thumb finding
                    thumb_lst1.Visible = false;
                }
            }
            else
            {
                // video not published yet
                thumb_lst1.Visible = false;
            }
       }
    }

    private void Generate_Breadcrumb(string title)
    {
        string _root = Config.GetUrl();
        hm.HRef = _root;
        hm.InnerHtml = Resources.vsk.home;

        mc.HRef = _root + "myaccount/";
        mc.InnerHtml = Resources.vsk.myaccount;

        mv.HRef = _root + "myaccount/myvideos.aspx";
        mv.InnerHtml = Resources.vsk.myvideos;

        stat.InnerHtml = title;
    }
}