﻿using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Web.UI.HtmlControls;
using System.Text;
using System.Collections.Generic;


public partial class video2_Default : System.Web.UI.Page
{
    private VideoBLL _mediadalc = new VideoBLL();

    protected string title = "";

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            if (Request.Params["vid"] == null || Request.Params["vid"] == "" || !UtilityBLL.isDigit(Request.Params["vid"].ToString()))
            {
                Response.Redirect(Config.GetUrl("videos/"));
                return;
            }
            if (Request.Params["status"] != null)
            {
                if (Request.Params["status"] == "posted")
                    Config.ShowMessageV2(msg, Resources.vsk.video_message_01, "Success!", 1); //  "Video has been posted in response of this video."
                else if (Request.Params["status"] == "pending")
                    Config.ShowMessageV2(msg, Resources.vsk.video_message_02, "Success!", 1); // Video has been posted and will be appear shortly.
            }
            // SET VideoID -> Used through out page
            long VideoID = Convert.ToInt64(Request.Params["vid"]);
            // Load Video Information
            Load_Video_Information(VideoID);
        }
    }

    private void Load_Video_Information(long VideoID)
    {
        List<Video_Struct> _list = _mediadalc.Fetch_Record_v2(VideoID);
        if (_list.Count > 0)
        {
            string Video_Preview_Url = UrlConfig.Prepare_Video_Preview_Url(VideoID, title, false);
            title = _list[0].Title;
            // adult validation
            if (_list[0].isAdult == 1)
            {
                // 1:-> adult content, 0:-> non adult content
                if (Session["adultmember"] == null)
                {
                    Response.Redirect(Config.GetUrl("ValidateAdult.aspx?surl=" + Server.UrlEncode(Video_Preview_Url) + ""));
                    return;
                }
            }
           
            if (_list[0].isReviewed == 0)
            {
                Config.ShowMessageV2(msg, "Selected video is waiting for moderator approval", "Error!", 0);
            }
            if (_list[0].isEnabled == 0)
            {
                Config.ShowMessageV2(msg, "Selected video has been disabled or blocked by site administrator", "Error!", 0);
            }

            pnl_main.Visible = true;
            // Get information

            DateTime date_added = _list[0].Date_Added;
            string username = _list[0].UserName;
            string description = _list[0].Description;
            int categoryid = _list[0].CategoryID;
            string tags = _list[0].Tags;
            string flv_url = _list[0].FLV_Url;
            string videofilename = _list[0].VideoFileName;
            string thumb_url = _list[0].Thumb_Url;
            string thumbfilename = _list[0].ThumbFileName;
            long response_videoid = _list[0].Response_VideoID;
            int total_rating = _list[0].Total_Rating;
            double ratings = _list[0].Ratings;
            int views = _list[0].Views;
            int comments = _list[0].Comments;
            int favorites = _list[0].Favorites;
            int responses = _list[0].Responses;
            double avg_rating = _list[0].Avg_Rating;
            int isexternal = _list[0].isExternal;

            // top user information
            t_usr_info1.VideoID = VideoID;
            t_usr_info1.UserName = username;
            t_usr_info1.Uploaded_Videos = _list[0].Uploaded_Videos;
           
            // video info
            vd_info1.ContentID = VideoID;
            vd_info1.Description = _list[0].Description;
            vd_info1.Added_Date = _list[0].Date_Added;
            vd_info1.UserName = _list[0].UserName;
            vd_info1.CategoryID = _list[0].CategoryID;
            vd_info1.CategoryName = _list[0].Categories;
            vd_info1.Tags = _list[0].Tags;
            vd_info1.Liked = _list[0].Liked;
            vd_info1.Disliked = _list[0].Disliked;
            

            //******************************************
            // Increment Video Views
            //****************************************
            if (Site_Settings.Feature_Filter != 1)
            {
                // simple view statistics
                _list[0].Views = _list[0].Views + 1;
                VideoBLL.Update_Field(VideoID, _list[0].Views.ToString(), "views");
            }
            else
            {
                // scalability wise not recommended
                // wide range of view statistics 
                int itemtype = 1; // represent videos
                ViewStatsBLL.Process_View_Stats(VideoID, itemtype, _list[0].Views);
            }
            views = views + 1;
        
            //*******************************************
            // Close Increment Views
            //*******************************************

            string video_preview_url = UrlConfig.Prepare_Video_Preview_Url(VideoID, title, false);
            // Video Path settings
            string VideoPath = Config.Return_FLV_Video_Url(flv_url, username) + "/" + videofilename;
            // Thumbnail Path
            string PictureName = "";
            if (thumb_url != "none")
                PictureName = thumb_url;
            else
                PictureName = Config.Return_Video_Thumb_Url(thumb_url, username) + "/" + thumbfilename;

            string _script = _list[0].Embed_Script;

            string MP4Path = "";
            if (VideoPath.EndsWith(".webm"))
                MP4Path = VideoPath.Replace(".webm", ".mp4");

            //*****************************************************************
            // PLAYER SETUP SCRIPT
            //*****************************************************************
            player1.Duration = _list[0].Duration_Sec.ToString();
            player1.Skin = Config.GetUrl("player/skins/bekle/bekle.swf");
            player1.Image = PictureName;
            // If cloud enabled
            if (_script != "" || _list[0].YoutubeID != "")
            {
                // third party embed video script enabled
                if (_script == "")
                    player1.Embed_Script = _list[0].YoutubeID;
                else
                    player1.Embed_Script = _script;
            }
           
            //*****************************************************************
            // CLOSE PLAYER SETUP SCRIPT
            //*****************************************************************
           
            // Like | Dislike Settings
            action1.ContentID = VideoID;
            action1.Liked = _list[0].Liked;
            action1.Disliked = _list[0].Disliked;
            action1.UserName = _list[0].UserName;
            action1.Favorites = _list[0].Favorites;
            action1.VideoFileName = videofilename;
            action1.VideoPath = VideoPath;
            action1.isRating = _list[0].isRatings;
            action1.Views = _list[0].Views;
            action1.Comments = _list[0].Comments;
            action1.Content_Type = "video";
            //// Five star rating options
            //action1.Avg_Ratings= _list[0].Avg_Rating;
            //action1.TotalRatings = _list[0].Total_Rating;
            //action1.Ratings = _list[0].Ratings;
            //vd_info1.ShowLikeBox = false; // hide like / dislike box from info section if rating is on
            // related videos
            related1.Tags = tags;
            related1.Title = title;
            related1.VideoID = VideoID;
            related1.CategoryID = _list[0].CategoryID;
            related1.AlbumId = _list[0].GalleryID;

            // text comments and video responses
            cmt1.ContentID = VideoID;
            cmt1.Type = 0;
            cmt1.TotalComments = comments;
            cmt1.isComment = _list[0].isComments;
            cmt1.PageSize = 20;
            cmt1.Text_Caption = "Respond to this Video";
            cmt1.ContentType = "Video";
            cmt1.AuthorUserName = username;
            cmt1.See_All_Text = "see all";
            cmt1.See_All_Tooltip = "Browse all comments";
            cmt1.See_All_Url = "video/comments/" + VideoID + ".aspx";
            cmt1.ShowAuthorPhoto = false;
            cmt1.ShowReplyLink = true;
            cmt1.ShowVoteLink = true;
            cmt1.PaginationType = 0; //0: ajax pagination, 1: load more
            cmt1.BindList();

            // Videos Watch Counter for currently logged in and video watching user.
            // comment these lines if you not want to store video watching stat.
            //if (Page.User.Identity.IsAuthenticated)
            //{
            //    // increment user watch stat
            //    members.Increment_VideosWatch(Page.User.Identity.Name);
               
            //    // Not useful function, due to performance wise don't enable extra overhead functions.
            //    //if (Page.User.Identity.Name != username)
            //    //{
            //    //    // current video is not own by currently watching user
            //    //    // add video in user current history
            //    //    User_Video_HistoryBLL.Add(Page.User.Identity.Name, VideoID);
            //    //}
            //}

            // set meta information
            string meta_title = _list[0].Title;
            if (meta_title == "")
                meta_title = "Video No " + _list[0].VideoID;

            string _desc = UtilityBLL.StripHTML(_list[0].Description);
            if (_desc == "")
                _desc = _list[0].Title;
            else if (_desc.Length > 160)
                _desc = _desc.Substring(0, 160);

            string meta_description = _desc + ", date uploaded: " + _list[0].Date_Added + ", VID: " + _list[0].VideoID;
            MetaTagsBLL.META_StaticPage(this.Page, (HtmlHead)Page.Header, meta_title, meta_description, PictureName, Video_Preview_Url);

            MetaTagsBLL.FB_META_V2(this.Page, (HtmlHead)Page.Header, meta_title, meta_description, PictureName, player1.FileName, Video_Preview_Url);
          
        }
        else
        {
            pnl_main.Visible = false;
            Config.ShowMessageV2(msg, Resources.vsk.message_05, "Error!", 0); // Record does't exist, may be blocked by administrator
        }
    }

    //protected void Page_PreRender(object sender, EventArgs e)
    //{
    //    if (!Page.IsPostBack)
    //    {
    //        // Tiptip JS Call
    //        HtmlGenericControl jsquery_ui_tooltip = new HtmlGenericControl("script");
    //        jsquery_ui_tooltip.Attributes.Add("type", "text/javascript");
    //        jsquery_ui_tooltip.Attributes.Add("src", Config.GetUrl() + "jquery/plugin/jquery.tipTip.js");
    //        Page.Header.Controls.Add(jsquery_ui_tooltip);
    //    }
    //}
}