﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;

using System.Collections.Generic;
using System.Text;

public partial class video_comments_Default : System.Web.UI.Page
{
    protected string VideoItem = ""; // Set Video Item shown on top of video response listing
    private VideoBLL _mediadalc = new VideoBLL();
   
    protected void Page_Load(object sender, EventArgs e)
    {

        if (!Page.IsPostBack)
        {
            if (Request.Params["vid"] == null || Request.Params["vid"] == "" || !UtilityBLL.isDigit(Request.Params["vid"].ToString()))
            {
                Response.Redirect( Config.GetUrl("Default.aspx"));
                return;
            }

            // SET VideoID -> Used through out page
            long VideoID= Convert.ToInt32(Request.Params["vid"]);

            // Load Video Information
            Load_Video_Information(VideoID);

        }
    }

    private void Load_Video_Information(long VideoID)
    {
        StringBuilder str = new StringBuilder();
        StringBuilder rotator_str = new StringBuilder();
        List<Video_Struct> _list = _mediadalc.Fetch_Record_SM(VideoID);
        if (_list.Count > 0)
        {
            // generate thumb rotator script for single video item                
            rotator_str.Append(UGeneral.Generate_Thumb_Rotator_Script(_list[0].ThumbFileName));
            // single comment item
            VideoItem video = new VideoItem();
            video.ShowDate = true;
            video.ShowTitle = true;
            video.ShowAuthor = true;
            video.ShowViews = true;
            video.BoxWidth = 0;
            video.Width = 200;
            video.Height = 150;
            video.BoxSpace = 0;
            video.isAdmin = false;
            video.isHoverEffect = false;
            video.TitleLength = 0;
            video.ContentLayout = 1;
            video.BoxWidth = 0;
            video.LeftWidth = 36; // %
            video.RightWidth = 63; // %
            video.BoldLinkCssClass = "big-text";
            video.DateCaption = "Posted:";
            video.DateFormat = 1;
            video.TitleLength = 0; // no restriction on photo title
            video.ShowDescription = true;
            video.DescriptionLength = 200;
            video.UserCaption = "Author:";

            if (_list[0].Description != "")
                _list[0].Description = UtilityBLL.StripHTML_v4(_list[0].Description); // remove html element
            _list[0].VideoID = VideoID;
            str.Append(video.Process(_list[0]));
            str.Append("<div class=\"clear\"></div>"); // clear floating items
            str.Append("<script type=\"text/javascript\">" + rotator_str.ToString() + "</script>"); // thumb rotator script
            this.VideoItem = str.ToString();

            // text comments
            cmt1.ContentID = VideoID;
            cmt1.Type = 0;
            cmt1.TotalComments = _list[0].Comments;
            cmt1.isComment = _list[0].isComments;
            cmt1.PageSize = 20;
            cmt1.Text_Caption = "Respond to this Video";
            cmt1.ContentType = "Video";
            cmt1.AuthorUserName = _list[0].UserName;
            cmt1.See_All_Text = "see all";
            cmt1.See_All_Tooltip = "Browse all comments";
            cmt1.See_All_Url = "video/comments/" + VideoID + ".aspx";
            cmt1.DefaultUrl = "video/comments/" + VideoID + ".aspx";
            cmt1.PaginationUrl = "video/comments/" + VideoID + "/[p].aspx";
            cmt1.ShowAuthorPhoto = false;
            cmt1.ShowReplyLink = true;
            cmt1.ShowVoteLink = true;
            cmt1.PaginationType = 2; //0: ajax pagination, 1: load more
            cmt1.BindList();
            // set meta information
            string meta_title = _list[0].Title + " Comments";
            if (meta_title == "")
                meta_title = "Video No " + _list[0].VideoID + " Comments";
            string _description = _list[0].Description;
            if (_description == "")
                _description = _list[0].Title;
            string meta_description = _description + ", " + _list[0].Comments + " comments posted , VID: " + _list[0].VideoID;
            MetaTagsBLL.META_StaticPage(this.Page, (HtmlHead)Page.Header, meta_title, meta_description, _list[0].Thumb_Url, UrlConfig.Prepare_Video_Preview_Url(_list[0].VideoID, _list[0].Title, false));

        }
        else
        {
            Config.ShowMessageV2(msg, Resources.vsk.message_05, "Error!", 0); // Record does't exist, may be blocked by administrator
        }
    }
    
}
